"use strict";

var _interopRequireDefault = require("@babel/runtime/helpers/interopRequireDefault");

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.ServerlessAnalyzeBundlePlugin = void 0;

var _regenerator = _interopRequireDefault(require("@babel/runtime/regenerator"));

var _asyncToGenerator2 = _interopRequireDefault(require("@babel/runtime/helpers/asyncToGenerator"));

var _createClass2 = _interopRequireDefault(require("@babel/runtime/helpers/createClass"));

var _classCallCheck2 = _interopRequireDefault(require("@babel/runtime/helpers/classCallCheck"));

var _bundleVisualizer = _interopRequireDefault(require("./bundleVisualizer"));

var ServerlessAnalyzeBundlePlugin = /*#__PURE__*/(0, _createClass2["default"])(function ServerlessAnalyzeBundlePlugin(serverless, options) {
  var _this = this;

  (0, _classCallCheck2["default"])(this, ServerlessAnalyzeBundlePlugin);
  this.bundleVisualizer = _bundleVisualizer["default"].bind(this);
  this.options = options;
  this.serverless = serverless;
  this.commands = {
    "package": {
      usage: 'Analyze the bundle of a lambda function',
      options: {
        analyze: {
          // @ts-expect-error plugin is badly typed 🤔
          type: 'string',
          usage: 'Specify the function you want to analyze (e.g. "--analyze \'helloWorld\'")'
        }
      }
    }
  };
  this.hooks = {
    'after:package:finalize': function () {
      var _afterPackageFinalize = (0, _asyncToGenerator2["default"])( /*#__PURE__*/_regenerator["default"].mark(function _callee() {
        var analyze;
        return _regenerator["default"].wrap(function _callee$(_context) {
          while (1) {
            switch (_context.prev = _context.next) {
              case 0:
                analyze = _this.options.analyze;

                if (!(analyze === undefined)) {
                  _context.next = 3;
                  break;
                }

                return _context.abrupt("return");

              case 3:
                _context.next = 5;
                return _this.bundleVisualizer();

              case 5:
              case "end":
                return _context.stop();
            }
          }
        }, _callee);
      }));

      function afterPackageFinalize() {
        return _afterPackageFinalize.apply(this, arguments);
      }

      return afterPackageFinalize;
    }()
  }; // The plugin requires metafile option to be true
  // We set it here (and not within a hook) because Serverless Framework keeps copies of service configuration
  // therefore overwriting changes made by hook functions

  var analyze = this.options.analyze;

  if (analyze === undefined) {
    return;
  } // eslint-disable-next-line @typescript-eslint/no-unsafe-member-access


  this.serverless.service.custom.esbuild.metafile = true;
});
exports.ServerlessAnalyzeBundlePlugin = ServerlessAnalyzeBundlePlugin;
//# sourceMappingURL=serverlessAnalyzeBundle.js.map