import _asyncToGenerator from "@babel/runtime/helpers/asyncToGenerator";
import _createClass from "@babel/runtime/helpers/createClass";
import _classCallCheck from "@babel/runtime/helpers/classCallCheck";
import _regeneratorRuntime from "@babel/runtime/regenerator";
import bundleVisualizer from './bundleVisualizer';
export var ServerlessAnalyzeBundlePlugin = /*#__PURE__*/_createClass(function ServerlessAnalyzeBundlePlugin(serverless, options) {
  var _this = this;

  _classCallCheck(this, ServerlessAnalyzeBundlePlugin);

  this.bundleVisualizer = bundleVisualizer.bind(this);
  this.options = options;
  this.serverless = serverless;
  this.commands = {
    "package": {
      usage: 'Analyze the bundle of a lambda function',
      options: {
        analyze: {
          // @ts-expect-error plugin is badly typed 🤔
          type: 'string',
          usage: 'Specify the function you want to analyze (e.g. "--analyze \'helloWorld\'")'
        }
      }
    }
  };
  this.hooks = {
    'after:package:finalize': function () {
      var _afterPackageFinalize = _asyncToGenerator( /*#__PURE__*/_regeneratorRuntime.mark(function _callee() {
        var analyze;
        return _regeneratorRuntime.wrap(function _callee$(_context) {
          while (1) {
            switch (_context.prev = _context.next) {
              case 0:
                analyze = _this.options.analyze;

                if (!(analyze === undefined)) {
                  _context.next = 3;
                  break;
                }

                return _context.abrupt("return");

              case 3:
                _context.next = 5;
                return _this.bundleVisualizer();

              case 5:
              case "end":
                return _context.stop();
            }
          }
        }, _callee);
      }));

      function afterPackageFinalize() {
        return _afterPackageFinalize.apply(this, arguments);
      }

      return afterPackageFinalize;
    }()
  }; // The plugin requires metafile option to be true
  // We set it here (and not within a hook) because Serverless Framework keeps copies of service configuration
  // therefore overwriting changes made by hook functions

  var analyze = this.options.analyze;

  if (analyze === undefined) {
    return;
  } // eslint-disable-next-line @typescript-eslint/no-unsafe-member-access


  this.serverless.service.custom.esbuild.metafile = true;
});
//# sourceMappingURL=serverlessAnalyzeBundle.js.map